"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  connect: () => connect,
  machine: () => machine
});
module.exports = __toCommonJS(src_exports);

// src/toggle.connect.ts
var import_dom_query2 = require("@zag-js/dom-query");

// src/toggle.dom.ts
var import_dom_query = require("@zag-js/dom-query");
var dom = (0, import_dom_query.createScope)({
  getButtonId: (ctx) => ctx.ids?.button ?? `toggle:${ctx.id}:button`
});

// src/toggle.anatomy.ts
var import_anatomy = require("@zag-js/anatomy");
var anatomy = (0, import_anatomy.createAnatomy)("toggle").parts("button");
var parts = anatomy.build();

// src/toggle.connect.ts
function connect(state, send, normalize) {
  const isPressed = state.context.pressed;
  const isDisabled = state.context.disabled;
  return {
    isPressed,
    setPressed(pressed) {
      send({ type: "PRESSED.SET", pressed });
    },
    buttonProps: normalize.button({
      ...parts.button.attrs,
      id: dom.getButtonId(state.context),
      type: "button",
      disabled: isDisabled,
      "aria-label": state.context["aria-label"],
      "aria-pressed": isPressed,
      "data-disabled": (0, import_dom_query2.dataAttr)(isDisabled),
      "data-state": isPressed ? "on" : "off",
      onClick() {
        if (isDisabled)
          return;
        send({ type: "PRESSED.TOGGLE" });
      }
    })
  };
}

// src/toggle.machine.ts
var import_core = require("@zag-js/core");
var import_utils = require("@zag-js/utils");
function machine(userContext) {
  const ctx = (0, import_utils.compact)(userContext);
  return (0, import_core.createMachine)(
    {
      id: "toggle",
      initial: "ready",
      context: {
        "aria-label": "Toggle",
        disabled: false,
        pressed: false,
        ...ctx
      },
      watch: {
        pressed: ["invokeOnChange"]
      },
      on: {
        "PRESSED.SET": {
          actions: ["setPressed"]
        },
        "PRESSED.TOGGLE": {
          actions: ["togglePressed"]
        }
      },
      states: {
        ready: {}
      }
    },
    {
      actions: {
        invokeOnChange(ctx2) {
          ctx2.onChange?.({ pressed: !!ctx2.pressed });
        },
        togglePressed(ctx2) {
          ctx2.pressed = !ctx2.pressed;
        },
        setPressed(ctx2, evt) {
          ctx2.pressed = evt.pressed;
        }
      }
    }
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  connect,
  machine
});
//# sourceMappingURL=index.js.map